TrcPktDecodeI Class Referenceabstract
OpenCSD Library : Packet Decoders.

`#include <trc_pkt_decode_base.h>`

Inheritance diagram for TrcPktDecodeI:
[legend]
Collaboration diagram for TrcPktDecodeI:
[legend]

## Public Member Functions

| TrcPktDecodeI (const char *component_name)
| TrcPktDecodeI (const char *component_name, int instIDNum)
virtual | ~TrcPktDecodeI ()
componentAttachPt< ITrcGenElemIn > * | getTraceElemOutAttachPt ()
componentAttachPt< ITargetMemAccess > * | getMemoryAccessAttachPt ()
componentAttachPt< IInstrDecode > * | getInstrDecodeAttachPt ()
void | setUsesMemAccess (bool bUsesMemaccess)
const bool | getUsesMemAccess () const
void | setUsesIDecode (bool bUsesIDecode)
const bool | getUsesIDecode () const
Public Member Functions inherited from TraceComponent
| TraceComponent (const std::string &name)
| TraceComponent (const std::string &name, int instIDNum)
virtual | ~TraceComponent ()
const std::string & | getComponentName () const
void | setComponentName (const std::string &name)
componentAttachPt< ITraceErrorLog > * | getErrorLogAttachPt ()
ocsd_err_t | setComponentOpMode (uint32_t op_flags)
const uint32_t | getComponentOpMode () const
const uint32_t | getSupportedOpModes () const
void | setAssocComponent (TraceComponent *assocComp)
TraceComponent * | getAssocComponent ()
void | LogDefMessage (const std::string &msg)

## Protected Member Functions

virtual ocsd_datapath_resp_t | processPacket ()=0
virtual ocsd_datapath_resp_t | onEOT ()=0
virtual ocsd_datapath_resp_t | onReset ()=0
virtual ocsd_datapath_resp_t | onFlush ()=0
virtual ocsd_err_t | onProtocolConfig ()=0
virtual const uint8_t | getCoreSightTraceID ()=0
const bool | checkInit ()
ocsd_datapath_resp_t | outputTraceElement (const OcsdTraceElement &elem)
ocsd_datapath_resp_t | outputTraceElementIdx (ocsd_trc_index_t idx, const OcsdTraceElement &elem)
ocsd_err_t | accessMemory (const ocsd_vaddr_t address, const ocsd_mem_space_acc_t mem_space, uint32_t *num_bytes, uint8_t *p_buffer)
ocsd_err_t | instrDecode (ocsd_instr_info *instr_info)
Protected Member Functions inherited from TraceComponent
void | LogError (const ocsdError &Error)
void | LogMessage (const ocsd_err_severity_t filter_level, const std::string &msg)
const ocsd_err_severity_t | getErrorLogLevel () const
const bool | isLoggingErrorLevel (const ocsd_err_severity_t level) const
void | updateErrorLogLevel ()
void | do_attach_notify (const int num_attached)
void | Init (const std::string &name)

## Protected Attributes

componentAttachPt< ITrcGenElemIn > | m_trace_elem_out
componentAttachPt< ITargetMemAccess > | m_mem_access
componentAttachPt< IInstrDecode > | m_instr_decode
ocsd_trc_index_t | m_index_curr_pkt
bool | m_decode_init_ok
| set true if all attachments in place for decode. (remove checks in main throughput paths) More...
bool | m_config_init_ok
| set true if config set. More...
std::string | init_err_msg
| error message for init error More...
bool | m_uses_memaccess
bool | m_uses_idecode
Protected Attributes inherited from TraceComponent
uint32_t | m_op_flags
| current component operational mode flags. More...
uint32_t | m_supported_op_flags
| supported component operational mode flags - derived class to intialise. More...

## Detailed Description

Definition at line 61 of file trc_pkt_decode_base.h.

## Constructor & Destructor Documentation

## ~TrcPktDecodeI()

virtual TrcPktDecodeI::~TrcPktDecodeI | ( |  | ) |

inline virtual

Definition at line 66 of file trc_pkt_decode_base.h.

## Member Function Documentation

## getCoreSightTraceID()

virtual const uint8_t TrcPktDecodeI::getCoreSightTraceID | ( |  | ) |

protected pure virtual

Implemented in TrcPktDecodeEtmV3, TrcPktDecodePtm, TrcPktDecodeEtmV4I, and TrcPktDecodeStm.

Here is the caller graph for this function:

## getInstrDecodeAttachPt()

componentAttachPt<IInstrDecode>* TrcPktDecodeI::getInstrDecodeAttachPt | ( |  | ) |

inline

Definition at line 70 of file trc_pkt_decode_base.h.

Here is the caller graph for this function:

## getMemoryAccessAttachPt()

componentAttachPt<ITargetMemAccess>* TrcPktDecodeI::getMemoryAccessAttachPt | ( |  | ) |

inline

Definition at line 69 of file trc_pkt_decode_base.h.

Here is the caller graph for this function:

## getTraceElemOutAttachPt()

componentAttachPt<ITrcGenElemIn>* TrcPktDecodeI::getTraceElemOutAttachPt | ( |  | ) |

inline

Definition at line 68 of file trc_pkt_decode_base.h.

Here is the caller graph for this function:

## getUsesIDecode()

const bool TrcPktDecodeI::getUsesIDecode | ( |  | ) | const

inline

Definition at line 76 of file trc_pkt_decode_base.h.

Here is the caller graph for this function:

## getUsesMemAccess()

const bool TrcPktDecodeI::getUsesMemAccess | ( |  | ) | const

inline

Definition at line 73 of file trc_pkt_decode_base.h.

Here is the caller graph for this function:

## onEOT()

virtual ocsd_datapath_resp_t TrcPktDecodeI::onEOT | ( |  | ) |

protected pure virtual

Implemented in TrcPktDecodeEtmV3, TrcPktDecodePtm, TrcPktDecodeEtmV4I, and TrcPktDecodeStm.

## onFlush()

virtual ocsd_datapath_resp_t TrcPktDecodeI::onFlush | ( |  | ) |

protected pure virtual

Implemented in TrcPktDecodeEtmV3, TrcPktDecodePtm, TrcPktDecodeEtmV4I, and TrcPktDecodeStm.

## onProtocolConfig()

virtual ocsd_err_t TrcPktDecodeI::onProtocolConfig | ( |  | ) |

protected pure virtual

Implemented in TrcPktDecodeEtmV3, TrcPktDecodePtm, TrcPktDecodeEtmV4I, and TrcPktDecodeStm.

## onReset()

virtual ocsd_datapath_resp_t TrcPktDecodeI::onReset | ( |  | ) |

protected pure virtual

Implemented in TrcPktDecodeEtmV3, TrcPktDecodePtm, TrcPktDecodeEtmV4I, and TrcPktDecodeStm.

## processPacket()

virtual ocsd_datapath_resp_t TrcPktDecodeI::processPacket | ( |  | ) |

protected pure virtual

Implemented in TrcPktDecodeEtmV3, TrcPktDecodePtm, TrcPktDecodeEtmV4I, and TrcPktDecodeStm.

## setUsesIDecode()

void TrcPktDecodeI::setUsesIDecode | ( | bool | bUsesIDecode | ) |

inline

Definition at line 75 of file trc_pkt_decode_base.h.

## setUsesMemAccess()

void TrcPktDecodeI::setUsesMemAccess | ( | bool | bUsesMemaccess | ) |

inline

Definition at line 72 of file trc_pkt_decode_base.h.

## Member Data Documentation

## init_err_msg

std::string TrcPktDecodeI::init_err_msg

protected

error message for init error

Definition at line 109 of file trc_pkt_decode_base.h.

## m_config_init_ok

bool TrcPktDecodeI::m_config_init_ok

protected

set true if config set.

Definition at line 107 of file trc_pkt_decode_base.h.

## m_decode_init_ok

bool TrcPktDecodeI::m_decode_init_ok

protected

set true if all attachments in place for decode. (remove checks in main throughput paths)

Definition at line 106 of file trc_pkt_decode_base.h.

## m_index_curr_pkt

ocsd_trc_index_t TrcPktDecodeI::m_index_curr_pkt

protected

Definition at line 104 of file trc_pkt_decode_base.h.

## m_instr_decode

componentAttachPt<IInstrDecode> TrcPktDecodeI::m_instr_decode

protected

Definition at line 102 of file trc_pkt_decode_base.h.

## m_mem_access

componentAttachPt<ITargetMemAccess> TrcPktDecodeI::m_mem_access

protected

Definition at line 101 of file trc_pkt_decode_base.h.

## m_trace_elem_out

componentAttachPt<ITrcGenElemIn> TrcPktDecodeI::m_trace_elem_out

protected

Definition at line 100 of file trc_pkt_decode_base.h.

## m_uses_idecode

bool TrcPktDecodeI::m_uses_idecode

protected

Definition at line 112 of file trc_pkt_decode_base.h.

## m_uses_memaccess

bool TrcPktDecodeI::m_uses_memaccess

protected

Definition at line 111 of file trc_pkt_decode_base.h.

The documentation for this class was generated from the following file:

- /build/libopencsd-WqHKQU/libopencsd-0.12.2/decoder/include/common/trc_pkt_decode_base.h